.slack_notification:
  variables:
    SLACK_NOTIFY_FAILURE_ONLY: false
    SLACK_DISABLE_SUCCESS_NOTIFICATION: false
  after_script:
    - |
      # based off https://medium.com/@mrdevx/step-by-step-guide-integrating-slack-with-gitlab-ci-for-seamless-ci-cd-notifications-be76a54d3038
      if [[ -z "$SLACK_WEBHOOK" ]]; then
        echo SLACK_WEBHOOK environment variable not set
        exit 1
      fi

      DEPLOYMENT_DATE=$(date -u +"%Y-%m-%dT%H:%M:%SZ") 
      CI_JOB_STATUS_UPPER=${CI_JOB_STATUS^^}
      if [ "$CI_JOB_STATUS" == "success" ]; then
        EMOJI_STATUS=":white_check_mark:"
      else
        EMOJI_STATUS=":exclamation:"
      fi

      # evaluate disabling conditions

      if ([[ "$SLACK_NOTIFY_FAILURE_ONLY" == "true" ]] || [[ "$SLACK_NOTIFY_FAILURE_ONLY" == "1" ]]) && [[ "$CI_JOB_STATUS_UPPER" != "FAILED" ]]; then
        echo job status is $CI_JOB_STATUS_UPPER, will not notify
        exit 0
      fi

      if ([[ "$SLACK_DISABLE_SUCCESS_NOTIFICATION" == "true" ]] || [[ "$SLACK_DISABLE_SUCCESS_NOTIFICATION" == "1" ]]) && [[ "$CI_JOB_STATUS_UPPER" == "SUCCESS" ]]; then
        echo will not notify SUCCESS status
        exit 0
      fi

      curl -X POST -H 'Content-type: application/json' --data "{
        \"text\": \"*Project:* $CI_PROJECT_NAME\n*Job:* $CI_JOB_NAME\n*Stage:* $CI_JOB_STAGE\n*User:* $GITLAB_USER_NAME\n*Deployment Date:* $DEPLOYMENT_DATE\n*Status:* $CI_JOB_STATUS_UPPER $EMOJI_STATUS\n*Details:* <$CI_JOB_URL|Job Details>\",
        \"mrkdwn\": true
      }" $SLACK_WEBHOOK;

